

/* Interfaccia del programma: compitoB  Messaggio  NumeroIntero */

/* dove Messaggio rappresenta una stringa e NumeroIntero un numero intero compreso fra 1 e 2. */

/* Il processo iniziale P0 deve generare due processi figli P1 e P2. Se il valore di */

/* NumeroIntero  1, il processo P0 deve comunicare a P1 la stringa Messaggio, e ordinare */ 

/* a P2 di terminare la sua esecuzione solo dopo che P1 ha stampato Messaggio a video. */

/* Viceversa, se il valore di NumeroIntero  2, il processo P0 deve comunicare a P2 la */

/* stringa Messaggio, e ordinare a P1 di terminare la sua esecuzione solo dopo la stampa */

/* a video di Messaggio da parte di P2. */



#include <stdio.h>

#include <signal.h>

#include <fcntl.h>

#define BUFSIZE 80



void handler(int sig_no);

int numero;





main(argc, argv)

int argc;

char **argv;



{

int pid1,pid2,piped[2],status,nwrite;

char buffer[BUFSIZE];



if (argc<3)

	{printf("Numero errato di parametri\n");

	exit(1);

	}

if ((strcmp(argv[2],"1")==0)&&(strcmp(argv[2],"2")==0))

	{printf("Secondo parametro deve essere 1 o 2\n");

	exit(2);

	}

numero=atoi(argv[2]);



if (pipe(piped)<0)

	{printf("Errore creazione pipe\n");

	exit(3);

	}



signal(SIGUSR1,handler);



if ((pid1=fork())<0)

	{printf("Errore prima fork\n");

	exit(4);

	}



if (pid1==0)		/* Figlio 1 */

	{if (numero==1)

		{close(piped[1]);

		read(piped[0],buffer,BUFSIZE);

		printf("Messaggio: %s\n",buffer);

		close(piped[0]);

		exit(0);

		}

	else	{close(piped[0]); close(piped[1]);

		pause();

		exit(0);

		}

	}

else		/* Padre */

	{if ((pid2=fork())<0)

		{printf("Errore seconda fork\n");

		exit(5);

		}

	if (pid2==0)		/* Figlio 2 */

		if (numero==2)

			{close(piped[1]);

			read(piped[0],buffer,BUFSIZE);

			printf("Messaggio: %s\n",buffer);

			close(piped[0]);

			exit(0);

			}

		else	{close(piped[0]); close(piped[1]);

			pause();

			exit(0);

			}

	}



/* Padre */

close(piped[0]);

if ((nwrite=write(piped[1],argv[1],BUFSIZE))<strlen(buffer))

	{printf("Errore nella scrittura pipe");

	exit(6);

	}

wait(&status);

if (numero==1) kill(pid2,SIGUSR1);

else	kill(pid1,SIGUSR1);

wait(&status);

close(piped[1]);

exit(0);



}





void handler(int sig_no)

	

{if (numero==1) printf("Sono P1 e termino\n");

else	printf("Sono P2 e termino\n");

}

