

/* Interfaccia del programma: compitoA  Numero NomeFile */

/* Il processo iniziale P0 deve generare due processi figli P1 e P2. P0 deve comunicare */

/* a P1 i primi Numero caratteri di NomeFile, e a P2 i successivi Numero caratteri */

/* sempre dello stesso file NomeFile. P1 e P2 devono contare i caratteri maiuscoli ricevuti */

/* e comunicare il superamento di 3 maiuscole a P0 tramite scambio di segnali. */





#include <stdio.h>

#include <signal.h>

#include <fcntl.h>





void handler(int sig_no);

int maiuscole=0;





main(int argc,char **argv)



{int fd,piped1[2],piped2[2],numero,pid1,pid2,cont=0,status;

int nread,totread;

char buf[1];



if (argc!=3)

	{printf("Il programma prevede due argomenti\n");

	exit(1);

	}

if ((numero=atoi(argv[1]))==0)

	{printf("Il primo argomento deve essere un intero\n");

	exit(2);

	}

if ((fd=open(argv[2],O_RDONLY))<0)

	{printf("Errore nell'apertura del file\n");

	exit(3);

	}



signal(SIGUSR1,handler);



if (pipe(piped1)<0)

	{printf("Errore nella creazione prima pipe");

	exit(4);

	}

if ((pid1=fork())<0)

	{printf("Errore nella generazione di P1");

	exit(5);

	}



if (pid1==0)		/* Codice P1 */

	{close(fd);

	close(piped1[1]);

	while (read(piped1[0],buf,1)==1)

		if ((buf[0]<='Z')&&(buf[0]>='A')) cont++;

	close(piped1[0]);

	if (cont>3)

		kill(getppid(),SIGUSR1);

	exit(0);

	}



if (pipe(piped2)<0)

	{printf("Errore nella creazione seconda pipe");

	exit(6);

	}

if ((pid2=fork())<0)		/* Padre */

	{printf("Errore nella generazione di P2");

	exit(7);

	}



if (pid2==0)		/* Codice P2 */

	{close(fd);

	close(piped1[0]);close(piped1[1]);close(piped2[1]);

	while (read(piped2[0],buf,1)==1)

		if ((buf[0]<='Z')&&(buf[0]>='A')) cont++;

	close(piped2[0]);

	if (cont>3)

		kill(getppid(),SIGUSR1);

	exit(0);

	}



close(piped1[0]);close(piped2[0]);				/* Ancora il padre P0 */



while ((nread=read(fd,buf,1)==1)&&(totread<numero))

	{if (write(piped1[1],buf,1)<1)

		{printf("Errore nella scrittura su pipe1");

		exit(8);

		}

	totread++;

	}

close(piped1[1]);

totread=0;

while ((nread=read(fd,buf,1)==1)&&(totread<numero))

	{if (write(piped2[1],buf,1)<1)

		{printf("Errore nella scrittura su pipe2");

		exit(9);

		}

	totread++;

	}

close(piped2[1]);



wait(&status);wait(&status);



if (maiuscole==2)

	printf("Sicuramente piu' di 6 maiuscole sul file\n");

}





void handler(int sig_no)

{

maiuscole++;

signal(SIGUSR1,handler);

}



