

/* Interfaccia del programma: compitoB  NomeFile */

/* dove NomeFile  il nome assoulto di un file. Si devono avere tre processi: */

/* padre P0, figlio P1 e nipote P2. P0 deve leggere il primo carattere di NomeFile e */

/* comunicarlo a P1. P1 legge l'intero file, carattere per carattere, e lo comunica a P2 */ 

/* sostituendo con '$' tutte le occorrenze del carattere indicato da P0. */

/* P2 deve infine scrivere tutto ci che riceve sullo stesso file NomeFile. */



#include <stdio.h>

#include <signal.h>

#include <fcntl.h>





main(int argc,char **argv)



{int piped1[2],piped2[2],fd,pid1,pid2,status;

char buf[1],buf2[1];



if (argc!=2)

	{printf("Numero errato di parametri\n");

	exit(1);

	}

if ((fd=open(argv[1],O_RDONLY))<0)

	{printf("Nome di file passato come parametro non corretto\n");

	exit(2);

	}

if ((pipe(piped1))<0)

	{printf("Errore creazione pipe\n");

	exit(3);

	}

if ((pid1=fork())<0)

	{printf("Errore generazione di P1\n");

	exit(4);

	}



if (pid1>0)			/* Processo P0 */

	{close(piped1[0]);

	if (read(fd,buf,1)<1)

		{printf("Errore lettura P0 sul file\n");

		exit(5);

		}

	close(fd);

	if (write(piped1[1],buf,1)<1)

		{printf("Errore scrittura P0 su pipe\n");

		exit(6);

		}

	close(piped1[1]);

	wait(&status);

	exit(0);

	}





close(piped1[1]);close(fd);		/* Processo P1 */

if (pipe(piped2)<0)

	{printf("Errore creazione pipe\n");

	exit(7);

	}

if ((pid2=fork())<0)		

		{printf("Errore seconda fork\n");

		exit(8);

		}

if (pid2>0)	

	{if (read(piped1[0],buf,1)<1)

		{printf("Errore lettura P1 su pipe\n");

		exit(9);

		}

	close(piped1[0]);close(piped2[0]);

	if ((fd=open(argv[1],O_RDONLY))<0)

		{printf("Errore apertura file da parte di P1\n");

		exit(10);

		}

	while(read(fd,buf2,1)==1)

		{if(buf2[0]==buf[0]) write(piped2[1],"$",1);

		else write(piped2[1],buf2,1);

		}

	close(fd);close(piped2[1]);

	wait(&status);exit(0);

	}





close(piped2[1]);	close(piped1[0]);		/* Processo P2 */

if ((fd=open(argv[1],O_WRONLY))<0)

		{printf("Errore apertura file da parte di P2\n");

		exit(11);

		}

while(read(piped2[0],buf,1)==1)

	write(fd,buf,1);

close(fd);close(piped2[0]);

}

